/*********************************************
ESTRUCTURA DE DATOS Y ALGORITMOS. ELO-320
TAREA 5
PROFESOR: AGUSTIN GONZALEZ V.

AUTORES:
EDUARDO GONZALEZ
KENNETH STUART
**********************************************/

#include "definiciones.h"

extern ARCO *crear_arco(int,int,float);
extern ARCO *insertar_arco(ARCO *, ARCO *,int);
extern ARCO *sort_lista(ARCO *);
extern ARCO *primer_arco(ARCO *);
extern NODO *crear_nodo(int,int);
extern NODO *buscar_nodo(NODO *,int);
extern NODO *insertar_nodo(NODO *, NODO *,int);
extern void revisar_arcos(int, ARCO *, NODO *, NODO *);


int main(int argc, char *argv[]){
  FILE *archivo;
  int numlineas = 0;
  int nodo_1, nodo_2;
  float peso,peso_total = 0;
  int i;
  ARCO *tramo = NULL;
  ARCO *lista_arcos = NULL; // puntero a una lista doblemente enlazada de arcos
  ARCO *inutil; // variable auxiliar
  NODO *vertice; // utilizado en la creacion de nodos
  NODO *lista_nodos = NULL; // puntero a una lista doblemente enlazada de nodos
  NODO *alfa, *beta;
  NODO *vocero; // puntero al nodo representante

  /*Verificar el ingreso de parametros*/
  if ( argc == 2) {
    if ( ( archivo = fopen(argv[1],"r") ) == NULL ) {
      printf("Archivo de texto inexistente\nUso: %s [Archivo de Texto]\n",argv[0]);
      exit(0);
    }
  }
  else {
    printf("\nIngrese como argumento el nombre de un archivo de texto\n> ");
    printf("Uso: %s [Archivo de Texto]\n",argv[0]);
    exit(0);
  }

  while (feof(archivo)==0) if (fgetc(archivo)=='\n') numlineas++; //cuenta cuantas lineas tiene el archivo

  rewind(archivo); // reinicia el puntero al archivo, apuntando ahora al inicio de este.
  printf("Los arcos leidos desde el archivo son:\n");

  /* Lee el archivo */
  while(feof(archivo)==0) {
    fscanf(archivo,"%d%d%f\n",&nodo_1,&nodo_2,&peso);
    printf("\t%d -- %d  %.2f\n",nodo_1,nodo_2,peso);
    tramo = crear_arco(nodo_1,nodo_2,peso); // crear un arco
    lista_arcos = insertar_arco(lista_arcos,tramo,0); // agregar el arco a la lista
  }
  fclose(archivo);

  printf("\n");

  tramo = lista_arcos;
  /* lee los arcos y crea los nodos */
  while (tramo!=NULL) {
    if ((vertice=buscar_nodo(lista_nodos,tramo->nodo_1))==NULL) { // busca si existe el nodo, en caso contrario, lo crea
      vertice = crear_nodo(tramo->nodo_1,numlineas+1);  // crear un nodo
      lista_nodos = insertar_nodo(lista_nodos,vertice,0); // agregar el nodo a la lista
    }
    for (i=0;i<numlineas;i++) if(vertice->adyacentes[i]==-1) break;
    vertice->adyacentes[i] = tramo->nodo_2; // agregar al nodo, su nuevo adyacente

    if ((vertice=buscar_nodo(lista_nodos,tramo->nodo_2))==NULL) { // el mismo proceso de crear un nodo , pero para el otro.
      vertice = crear_nodo(tramo->nodo_2,numlineas+1);
      lista_nodos = insertar_nodo(lista_nodos,vertice,0);
    }
    for (i=0;i<numlineas;i++) if(vertice->adyacentes[i]==-1) break;
    vertice->adyacentes[i] = tramo->nodo_1;

    tramo = tramo->siguiente; // siguiente arco
  }

  /* Ordenar la lista de menor a mayor, segun peso, y mostrar en pantalla */
  tramo = sort_lista(lista_arcos);
  tramo = primer_arco(tramo); // tramo es el primer arco de la lista
  inutil = tramo;
  printf("Lista de arcos ordenados de menor a mayor PESO:\n");
  while (inutil!=NULL) {
    printf("\t%.2f\t%d -- %d\n",inutil->peso,inutil->nodo_2,inutil->nodo_1);
    inutil = inutil->siguiente;
  }

  /********************************/
  /* Discrima los arcos para la solucion MST */
  printf("\nSolucion MST, mediante algoritmo de Kruskal:\n");
  vocero = buscar_nodo(lista_nodos,tramo->nodo_1); // define al representante
  vocero->representante = vocero;
  while (tramo!=NULL) {
    alfa = buscar_nodo(lista_nodos,tramo->nodo_1); // nodo correspondiente al primer nodo del arco
    beta = buscar_nodo(lista_nodos,tramo->nodo_2); // nodo correspondiente al segundo nodo del arco
    if ( (alfa->representante != vocero) || (beta->representante != vocero)) { //si alguno de los nodo no esta en la solucion...
      if (alfa->representante != vocero && beta->representante == vocero ) { // alfa no esta.. pero si beta
	alfa->representante = vocero; // definir representante
	revisar_arcos(tramo->nodo_1,tramo,vocero,lista_nodos); // definir representante de los arcos conectados a alfa
      }
      if (beta->representante != vocero && alfa->representante == vocero  ) { // beta no esta.. pero si alfa
	beta->representante = vocero; // definir representante
	revisar_arcos(tramo->nodo_2,tramo,vocero,lista_nodos); // definir representante de los arcos conectados a beta
      }
      peso_total += tramo->peso; // agrega el peso del arco al peso de la solucion
      printf("arco: %d -- %d  forma parte de la solucion y tiene un peso de: %.3f\n",tramo->nodo_1,tramo->nodo_2,tramo->peso);
    }
    tramo = tramo->siguiente; // siguiente arco
  }
  printf("\nEl costo del arbol es: %.3f\n",peso_total);
  return (int)(peso_total*1000);
}
