#include "definiciones.h"


ARCO *crear_arco(int,int,float);
ARCO *insertar_arco(ARCO *, ARCO *,int);
NODO *crear_nodo(int,int);
NODO *buscar_nodo(NODO *,int);
NODO *insertar_nodo(NODO *, NODO *,int);
void revisar_arcos(int, ARCO *, NODO *, NODO *);


/* CREA UN ARCO */
ARCO *crear_arco(int n1, int n2 ,float weight) {
  ARCO *nuevo;
  if ((nuevo = (ARCO *)malloc(sizeof(ARCO)))==NULL) {
    printf("Error interno del programa.... terminando.\n");
    exit(0);
  }
  nuevo->nodo_1 = n1;
  nuevo->nodo_2 = n2;
  nuevo->peso = weight;
  return nuevo;
}

/* INSERTAR UN ARCO A UNA LISTA */
ARCO *insertar_arco(ARCO *lista, ARCO *tramo,int pos) {
  int p=0;
  ARCO *aux = lista;
  ARCO *ant = NULL;
  if (pos<0) return NULL;
  while ( (p<pos) && (aux->siguiente != NULL) ) {
    p++;
    ant = aux;
    aux = aux->siguiente;
  }
  if (ant!=NULL) ant->siguiente = tramo;
  else lista = tramo;
  tramo->anterior = ant;
  if (aux!=NULL) aux->anterior = tramo;
  tramo->siguiente = aux;
  return lista;
}

/* CREAR UN NODO */
NODO *crear_nodo(int id,int m) {
  NODO *nuevo;
  int *arreglo;
  int i;
  if ((nuevo = (NODO *)malloc(sizeof(NODO)))==NULL) {
    printf("Error interno del programa....terminando.\n");
    exit(0);
  }
  if ((arreglo = (int *)malloc(m*sizeof(int)))==NULL) {
    printf("Error interno del programa....terminando\n");
    exit(0);
  }
  for (i=0;i<m-1;i++) arreglo[i] = -1;
  nuevo->id = id;
  nuevo->adyacentes = arreglo;
  nuevo->siguiente = NULL;
  nuevo->anterior = NULL;
  nuevo->representante = nuevo;
  return nuevo;
}

/* BUSCAR UN NODO */
NODO *buscar_nodo(NODO *lista,int num) {
  NODO *aux;
  aux = lista;
  while ((aux != NULL)) {
    if (aux->id == num) break;
    aux = aux->siguiente;
  }
  return aux;
}

/* INSERTAR UN NODO A UNA LISTA */
NODO *insertar_nodo(NODO *lista, NODO *vert,int pos) {
  int p=0;
  NODO *aux;
  NODO *ant;
  aux = lista;
  ant = NULL;
  if (pos<0) return NULL;
  while ( (p<pos) && (aux->siguiente != NULL) ) {
    p++;
    ant = aux;
    aux = aux->siguiente;
  }
  if (ant!=NULL) ant->siguiente = vert;
  else lista = vert;
  vert->anterior = ant;
  if (aux!=NULL) aux->anterior = vert;
  vert->siguiente = aux;
  return lista;
}

/* FUNCION PARA MARCAR REPRESENTANTE DE LOS NODOS CONECTADOS AL NODO ID POR MEDIO DE UN ARCO QUE ESTE EN LA SOLUCION */
void revisar_arcos(int id, ARCO *tramo, NODO *vocero, NODO *lista) {
  NODO *alfa, *beta;
  alfa = buscar_nodo(lista,tramo->nodo_1);
  beta = buscar_nodo(lista,tramo->nodo_2);   
  if (tramo->nodo_1 == id && beta->representante != vocero) 
    beta->representante = vocero;
  else if (tramo->nodo_2 == id && alfa->representante != vocero) 
    alfa->representante = vocero;
  if (tramo->anterior != NULL) revisar_arcos(id,tramo->anterior,vocero,lista); // revisa otros arcos
  else return;
}




