#include "definiciones.h"


int arco_menorque(ARCO *, ARCO *);
int largo_lista( ARCO *);


/* busca el ultimo arco en una lista */
ARCO * ultimo_arco(ARCO * lista) {
  if (lista==NULL) return NULL;
  if (lista->siguiente == NULL) return lista;
  return ultimo_arco(lista->siguiente);
}

/* busca el primer arco en una lista */
ARCO * primer_arco(ARCO * lista) {
  if (lista==NULL) return NULL;
  if (lista->anterior == NULL) return lista;
  return primer_arco(lista->anterior);
}


/* intercambia los valores en los arcos a y b */
void swap_val_arcos(ARCO * a, ARCO * b) {
  float w;
  int n1,n2;

  n1 = a->nodo_1;
  n2 = a->nodo_2;
  a->nodo_1 = b->nodo_1;
	a->nodo_2 = b->nodo_2;
  b->nodo_1 = n1;
	b->nodo_2 = n2;
  w = a->peso;
  a->peso = b->peso;
  b->peso = w;

}


/* ordena la lista */
ARCO * sort_lista(ARCO * lista) { //lista es el primer arco de la lista
  //compara la lista de atras hacia adelante, dejando los mayores al final.
  ARCO * aux, * piv, * tmp, * inicio;
  int largo;
  if (lista==NULL) return NULL;
  largo = largo_lista(lista);
  piv = ultimo_arco(lista);
  if (piv->anterior == NULL) return lista;
  inicio = lista;
  aux = piv->anterior;
  while (1) {
    if(aux == NULL) break;
    if (arco_menorque(aux,piv)==0 ) {
      if (inicio==aux) inicio=piv;
      swap_val_arcos(aux,piv);
    }
    if (aux->anterior!=NULL){
      aux = aux->anterior;
    }
    else {
      piv = piv->anterior;
      if (piv==inicio) break;
      aux = piv->anterior;
    }
  }
  return inicio;
}

/* compara los nodos a y b, retorna 1 si a es menor en frecuencia, y mayor (posterior) alfabeticamente */
int arco_menorque(ARCO * a, ARCO * b) {
  if (a->peso < b->peso) return 1;
  else return 0;
}


/* retorna la cantidad de nodos en la lista, apartir del arco 'primer' */
int largo_lista( ARCO * primer ) {
  if (primer==NULL) return 0;
  return 1 + largo_lista(primer->siguiente);
}


